/*
 * This file was generated by the CommonAPI Generators.
 * Used org.genivi.commonapi.someip 3.2.0.v202012010944.
 * Used org.franca.core 0.13.1.201807231814.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
 * If a copy of the MPL was not distributed with this file, You can obtain one at
 * http://mozilla.org/MPL/2.0/.
 */
#ifndef V1_COMMONAPI_TELUX_CV2X_CV2X_RADIO_SOMEIP_PROXY_HPP_
#define V1_COMMONAPI_TELUX_CV2X_CV2X_RADIO_SOMEIP_PROXY_HPP_

#include <v1/commonapi/telux/cv2x/Cv2xRadioProxyBase.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesSomeIPProxy.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesSomeIPDeployment.hpp>
#include <v1/commonapi/telux/common/CommonDefinesSomeIPDeployment.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/SomeIP/Factory.hpp>
#include <CommonAPI/SomeIP/Proxy.hpp>
#include <CommonAPI/SomeIP/Types.hpp>
#include <CommonAPI/SomeIP/Event.hpp>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <string>

# if defined(_MSC_VER)
#  if _MSC_VER >= 1300
/*
 * Diamond inheritance is used for the CommonAPI::Proxy base class.
 * The Microsoft compiler put warning (C4250) using a desired c++ feature: "Delegating to a sister class"
 * A powerful technique that arises from using virtual inheritance is to delegate a method from a class in another class
 * by using a common abstract base class. This is also called cross delegation.
 */
#    pragma warning( disable : 4250 )
#  endif
# endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace cv2x {

class Cv2xRadioSomeIPProxy
    : virtual public Cv2xRadioProxyBase,
      virtual public ::v1::commonapi::telux::cv2x::Cv2xRadioTypesSomeIPProxy {
public:
    Cv2xRadioSomeIPProxy(
        const CommonAPI::SomeIP::Address &_address,
        const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection);

    virtual ~Cv2xRadioSomeIPProxy();

    virtual CurrentCv2xStatusEvent& getCurrentCv2xStatusEvent();

    virtual CurrentCv2xStatusExEvent& getCurrentCv2xStatusExEvent();

    virtual CurrentL2AddrEvent& getCurrentL2AddrEvent();

    virtual CurrentSpsOffsetEvent& getCurrentSpsOffsetEvent();

    virtual CurrentCapabilitiesEvent& getCurrentCapabilitiesEvent();

    virtual MacAddrCloneEvent& getMacAddrCloneEvent();

    virtual void createRxSubscription(::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, uint16_t _port, std::vector< uint32_t > _idList, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, uint32_t &_subscriptionId, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> createRxSubscriptionAsync(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType &_ipType, const uint16_t &_port, const std::vector< uint32_t > &_idList, CreateRxSubscriptionAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void getServiceStatus(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::common::CommonDefines::ServiceStatus &_status, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> getServiceStatusAsync(GetServiceStatusAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void enableRxMetaDataReport(::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, bool _enable, std::vector< uint32_t > _idList, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> enableRxMetaDataReportAsync(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType &_ipType, const bool &_enable, const std::vector< uint32_t > &_idList, EnableRxMetaDataReportAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void createTxSpsFlow(::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, uint32_t _serviceId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo _spsInfo, uint16_t _spsSrcPort, bool _eventSrcPortValid, uint16_t _eventSrcPort, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, uint32_t &_txSpsFlowId, uint32_t &_txEventFlowId, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_spsError, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_eventError, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> createTxSpsFlowAsync(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType &_ipType, const uint32_t &_serviceId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo &_spsInfo, const uint16_t &_spsSrcPort, const bool &_eventSrcPortValid, const uint16_t &_eventSrcPort, CreateTxSpsFlowAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void createTxEventFlow(::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipTyp, uint32_t _serviceId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo _flowInfo, uint16_t _eventSrcPort, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, uint32_t &_txEventFlowId, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> createTxEventFlowAsync(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType &_ipTyp, const uint32_t &_serviceId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo &_flowInfo, const uint16_t &_eventSrcPort, CreateTxEventFlowAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void closeRxSubscription(uint32_t _subscriptionId, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> closeRxSubscriptionAsync(const uint32_t &_subscriptionId, CloseRxSubscriptionAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void closeTxFlow(uint32_t _txFlowId, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> closeTxFlowAsync(const uint32_t &_txFlowId, CloseTxFlowAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void changeSpsFlowInfo(uint32_t _txFlowId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo _spsInfo, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> changeSpsFlowInfoAsync(const uint32_t &_txFlowId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo &_spsInfo, ChangeSpsFlowInfoAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void requestSpsFlowInfo(uint32_t _txFlowId, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo &_spsInfo, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> requestSpsFlowInfoAsync(const uint32_t &_txFlowId, RequestSpsFlowInfoAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void changeEventFlowInfo(uint32_t _txFlowId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo _eventInfo, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> changeEventFlowInfoAsync(const uint32_t &_txFlowId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo &_eventInfo, ChangeEventFlowInfoAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void requestCapability(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities &_capabilities, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> requestCapabilityAsync(RequestCapabilityAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void getOwnVersion(uint16_t &_major, uint16_t &_minor) const;

    virtual std::future<void> getCompletionFuture();

private:
    CommonAPI::SomeIP::Event<CurrentCv2xStatusEvent, CommonAPI::Deployable< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xStatusDeployment_t >> currentCv2xStatus_;
    CommonAPI::SomeIP::Event<CurrentCv2xStatusExEvent, CommonAPI::Deployable< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatusEx, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xStatusExDeployment_t >> currentCv2xStatusEx_;
    CommonAPI::SomeIP::Event<CurrentL2AddrEvent, CommonAPI::Deployable< uint32_t, CommonAPI::SomeIP::IntegerDeployment<uint32_t> >> currentL2Addr_;
    CommonAPI::SomeIP::Event<CurrentSpsOffsetEvent, CommonAPI::Deployable< int32_t, CommonAPI::SomeIP::IntegerDeployment<int32_t> >, CommonAPI::Deployable< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::MacDetails, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::MacDetailsDeployment_t >> currentSpsOffset_;
    CommonAPI::SomeIP::Event<CurrentCapabilitiesEvent, CommonAPI::Deployable< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xRadioCapabilitiesDeployment_t >> currentCapabilities_;
    CommonAPI::SomeIP::Event<MacAddrCloneEvent, CommonAPI::Deployable< bool, CommonAPI::EmptyDeployment >> macAddrClone_;

    std::promise<void> completed_;
};

} // namespace cv2x
} // namespace telux
} // namespace commonapi
} // namespace v1

#endif // V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_SOMEIP_PROXY_HPP_
